Index: uspace/drv/char/msim-con/msim-con.c
===================================================================
--- uspace/drv/char/msim-con/msim-con.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/msim-con/msim-con.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,6 +43,6 @@
 static void msim_con_connection(ipc_callid_t, ipc_call_t *, void *);
 
-static errno_t msim_con_read(chardev_srv_t *, void *, size_t, size_t *);
-static errno_t msim_con_write(chardev_srv_t *, const void *, size_t, size_t *);
+static int msim_con_read(chardev_srv_t *, void *, size_t, size_t *);
+static int msim_con_write(chardev_srv_t *, const void *, size_t, size_t *);
 
 static chardev_ops_t msim_con_chardev_ops = {
@@ -66,5 +66,5 @@
 	msim_con_t *con = (msim_con_t *) arg;
 	uint8_t c;
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_lock(&con->buf_lock);
@@ -80,10 +80,10 @@
 
 /** Add msim console device. */
-errno_t msim_con_add(msim_con_t *con, msim_con_res_t *res)
+int msim_con_add(msim_con_t *con, msim_con_res_t *res)
 {
 	ddf_fun_t *fun = NULL;
 	bool subscribed = false;
 	irq_cmd_t *msim_cmds = NULL;
-	errno_t rc;
+	int rc;
 
 	circ_buf_init(&con->cbuf, con->buf, msim_con_buf_size, 1);
@@ -125,5 +125,5 @@
 	con->irq_code.cmds = msim_cmds;
 
-	async_irq_subscribe(res->irq, msim_irq_handler, con, &con->irq_code, NULL);
+	async_irq_subscribe(res->irq, msim_irq_handler, con, &con->irq_code);
 	subscribed = true;
 
@@ -152,5 +152,5 @@
 
 /** Remove msim console device */
-errno_t msim_con_remove(msim_con_t *con)
+int msim_con_remove(msim_con_t *con)
 {
 	return ENOTSUP;
@@ -158,5 +158,5 @@
 
 /** Msim console device gone */
-errno_t msim_con_gone(msim_con_t *con)
+int msim_con_gone(msim_con_t *con)
 {
 	return ENOTSUP;
@@ -169,5 +169,5 @@
 
 /** Read from msim console device */
-static errno_t msim_con_read(chardev_srv_t *srv, void *buf, size_t size,
+static int msim_con_read(chardev_srv_t *srv, void *buf, size_t size,
     size_t *nread)
 {
@@ -175,5 +175,5 @@
 	size_t p;
 	uint8_t *bp = (uint8_t *) buf;
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_lock(&con->buf_lock);
@@ -197,5 +197,5 @@
 
 /** Write to msim console device */
-static errno_t msim_con_write(chardev_srv_t *srv, const void *data, size_t size,
+static int msim_con_write(chardev_srv_t *srv, const void *data, size_t size,
     size_t *nwr)
 {
Index: uspace/drv/char/msim-con/msim-con.h
===================================================================
--- uspace/drv/char/msim-con/msim-con.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/msim-con/msim-con.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -70,7 +70,7 @@
 } msim_con_t;
 
-extern errno_t msim_con_add(msim_con_t *, msim_con_res_t *);
-extern errno_t msim_con_remove(msim_con_t *);
-extern errno_t msim_con_gone(msim_con_t *);
+extern int msim_con_add(msim_con_t *, msim_con_res_t *);
+extern int msim_con_remove(msim_con_t *);
+extern int msim_con_gone(msim_con_t *);
 
 #endif
Index: uspace/drv/char/ns8250/ns8250.c
===================================================================
--- uspace/drv/char/ns8250/ns8250.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/ns8250/ns8250.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,4 @@
 #include <stdio.h>
 #include <errno.h>
-#include <str_error.h>
 #include <stdbool.h>
 #include <fibril_synch.h>
@@ -251,5 +250,5 @@
  * @return		EOK on success or non-zero error code
  */
-static errno_t ns8250_read(chardev_srv_t *srv, void *buf, size_t count, size_t *nread)
+static int ns8250_read(chardev_srv_t *srv, void *buf, size_t count, size_t *nread)
 {
 	ns8250_t *ns = srv_ns8250(srv);
@@ -295,5 +294,5 @@
  * @return		EOK on success or non-zero error code
  */
-static errno_t ns8250_write(chardev_srv_t *srv, const void *buf, size_t count,
+static int ns8250_write(chardev_srv_t *srv, const void *buf, size_t count,
     size_t *nwritten)
 {
@@ -309,6 +308,6 @@
 }
 
-static errno_t ns8250_open(chardev_srvs_t *, chardev_srv_t *);
-static errno_t ns8250_close(chardev_srv_t *);
+static int ns8250_open(chardev_srvs_t *, chardev_srv_t *);
+static int ns8250_close(chardev_srv_t *);
 static void ns8250_default_handler(chardev_srv_t *, ipc_callid_t, ipc_call_t *);
 
@@ -324,6 +323,6 @@
 static void ns8250_char_conn(ipc_callid_t, ipc_call_t *, void *);
 
-static errno_t ns8250_dev_add(ddf_dev_t *dev);
-static errno_t ns8250_dev_remove(ddf_dev_t *dev);
+static int ns8250_dev_add(ddf_dev_t *dev);
+static int ns8250_dev_remove(ddf_dev_t *dev);
 
 /** The serial port device driver's standard operations. */
@@ -405,9 +404,9 @@
  *
  * @param ns		Serial port device
- * @return		Zero on success, error number otherwise
- */
-static errno_t ns8250_dev_initialize(ns8250_t *ns)
-{
-	errno_t ret = EOK;
+ * @return		Zero on success, negative error number otherwise
+ */
+static int ns8250_dev_initialize(ns8250_t *ns)
+{
+	int ret = EOK;
 	
 	ddf_msg(LVL_DEBUG, "ns8250_dev_initialize %s", ddf_dev_get_name(ns->dev));
@@ -499,10 +498,10 @@
  *
  * @param ns		Serial port device
- * @return		Zero on success, error number otherwise
- */
-static errno_t ns8250_interrupt_enable(ns8250_t *ns)
+ * @return		Zero on success, negative error number otherwise
+ */
+static int ns8250_interrupt_enable(ns8250_t *ns)
 {
 	/* Enable interrupt using IRC service. */
-	errno_t rc = hw_res_enable_interrupt(ns->parent_sess, ns->irq);
+	int rc = hw_res_enable_interrupt(ns->parent_sess, ns->irq);
 	if (rc != EOK)
 		return EIO;
@@ -544,8 +543,8 @@
  * @param port		The base address of the serial port device's ports.
  * @param baud_rate	The baud rate to be used by the device.
- * @return		Zero on success, error number otherwise (EINVAL
+ * @return		Zero on success, negative error number otherwise (EINVAL
  *			if the specified baud_rate is not valid).
  */
-static errno_t ns8250_port_set_baud_rate(ns8250_regs_t *regs, unsigned int baud_rate)
+static int ns8250_port_set_baud_rate(ns8250_regs_t *regs, unsigned int baud_rate)
 {
 	uint16_t divisor;
@@ -646,5 +645,5 @@
  *			is invalid.
  */
-static errno_t ns8250_port_set_com_props(ns8250_regs_t *regs, unsigned int parity,
+static int ns8250_port_set_com_props(ns8250_regs_t *regs, unsigned int parity,
     unsigned int word_length, unsigned int stop_bits)
 {
@@ -803,9 +802,8 @@
  * @param ns		Serial port device
  */
-static inline errno_t ns8250_register_interrupt_handler(ns8250_t *ns,
-    cap_handle_t *handle)
+static inline int ns8250_register_interrupt_handler(ns8250_t *ns)
 {
 	return register_interrupt_handler(ns->dev, ns->irq,
-	    ns8250_interrupt_handler, NULL, handle);
+	    ns8250_interrupt_handler, NULL);
 }
 
@@ -814,5 +812,5 @@
  * @param ns		Serial port device
  */
-static inline errno_t ns8250_unregister_interrupt_handler(ns8250_t *ns)
+static inline int ns8250_unregister_interrupt_handler(ns8250_t *ns)
 {
 	return unregister_interrupt_handler(ns->dev, ns->irq_cap);
@@ -825,5 +823,5 @@
  * @param dev		The serial port device.
  */
-static errno_t ns8250_dev_add(ddf_dev_t *dev)
+static int ns8250_dev_add(ddf_dev_t *dev)
 {
 	ns8250_t *ns = NULL;
@@ -831,5 +829,5 @@
 	bool need_cleanup = false;
 	bool need_unreg_intr_handler = false;
-	errno_t rc;
+	int rc;
 	
 	ddf_msg(LVL_DEBUG, "ns8250_dev_add %s (handle = %d)",
@@ -876,6 +874,6 @@
 	
 	/* Register interrupt handler. */
-	rc = ns8250_register_interrupt_handler(ns, &ns->irq_cap);
-	if (rc != EOK) {
+	ns->irq_cap = ns8250_register_interrupt_handler(ns);
+	if (ns->irq_cap < 0) {
 		ddf_msg(LVL_ERROR, "Failed to register interrupt handler.");
 		rc = EADDRNOTAVAIL;
@@ -888,5 +886,5 @@
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed to enable the interrupt. Error code = "
-		    "%s.", str_error_name(rc));
+		    "%d.", rc);
 		goto fail;
 	}
@@ -928,8 +926,8 @@
 }
 
-static errno_t ns8250_dev_remove(ddf_dev_t *dev)
+static int ns8250_dev_remove(ddf_dev_t *dev)
 {
 	ns8250_t *ns = dev_ns8250(dev);
-	errno_t rc;
+	int rc;
 	
 	fibril_mutex_lock(&ns->mutex);
@@ -963,8 +961,8 @@
  * @param srv		Server-side connection structure
  */
-static errno_t ns8250_open(chardev_srvs_t *srvs, chardev_srv_t *srv)
+static int ns8250_open(chardev_srvs_t *srvs, chardev_srv_t *srv)
 {
 	ns8250_t *ns = srv_ns8250(srv);
-	errno_t res;
+	int res;
 	
 	fibril_mutex_lock(&ns->mutex);
@@ -987,5 +985,5 @@
  * @param srv		Server-side connection structure
  */
-static errno_t ns8250_close(chardev_srv_t *srv)
+static int ns8250_close(chardev_srv_t *srv)
 {
 	ns8250_t *data = srv_ns8250(srv);
@@ -1040,5 +1038,5 @@
  * @param stop_bits	The number of stop bits to be used.
  */
-static errno_t ns8250_set_props(ddf_dev_t *dev, unsigned int baud_rate,
+static int ns8250_set_props(ddf_dev_t *dev, unsigned int baud_rate,
     unsigned int parity, unsigned int word_length, unsigned int stop_bits)
 {
@@ -1049,5 +1047,5 @@
 	ns8250_t *data = dev_ns8250(dev);
 	ns8250_regs_t *regs = data->regs;
-	errno_t ret;
+	int ret;
 	
 	fibril_mutex_lock(&data->mutex);
@@ -1072,5 +1070,5 @@
 	ns8250_t *ns8250 = srv_ns8250(srv);
 	sysarg_t method = IPC_GET_IMETHOD(*call);
-	errno_t ret;
+	int ret;
 	unsigned int baud_rate, parity, word_length, stop_bits;
 	
Index: uspace/drv/char/pl050/pl050.c
===================================================================
--- uspace/drv/char/pl050/pl050.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/pl050/pl050.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -35,5 +35,4 @@
 #include <stdio.h>
 #include <errno.h>
-#include <str_error.h>
 #include <ddf/driver.h>
 #include <ddf/interrupt.h>
@@ -51,10 +50,10 @@
 };
 
-static errno_t pl050_dev_add(ddf_dev_t *);
-static errno_t pl050_fun_online(ddf_fun_t *);
-static errno_t pl050_fun_offline(ddf_fun_t *);
+static int pl050_dev_add(ddf_dev_t *);
+static int pl050_fun_online(ddf_fun_t *);
+static int pl050_fun_offline(ddf_fun_t *);
 static void pl050_char_conn(ipc_callid_t, ipc_call_t *, void *);
-static errno_t pl050_read(chardev_srv_t *, void *, size_t, size_t *);
-static errno_t pl050_write(chardev_srv_t *, const void *, size_t, size_t *);
+static int pl050_read(chardev_srv_t *, void *, size_t, size_t *);
+static int pl050_write(chardev_srv_t *, const void *, size_t, size_t *);
 
 static driver_ops_t driver_ops = {
@@ -158,9 +157,9 @@
 }
 
-static errno_t pl050_init(pl050_t *pl050)
+static int pl050_init(pl050_t *pl050)
 {
 	hw_res_list_parsed_t res;
 	void *regs;
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_initialize(&pl050->buf_lock);
@@ -213,10 +212,10 @@
 	pl050->regs = regs;
 
-	int irq_cap;
-	rc = register_interrupt_handler(pl050->dev,
-	    res.irqs.irqs[0], pl050_interrupt, &pl050_irq_code, &irq_cap);
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed registering interrupt handler. (%s)",
-		    str_error_name(rc));
+	const int irq_cap = register_interrupt_handler(pl050->dev,
+	    res.irqs.irqs[0], pl050_interrupt, &pl050_irq_code);
+	if (irq_cap < 0) {
+		rc = irq_cap;
+		ddf_msg(LVL_ERROR, "Failed registering interrupt handler. (%d)",
+		    rc);
 		goto error;
 	}
@@ -224,5 +223,5 @@
 	rc = hw_res_enable_interrupt(pl050->parent_sess, res.irqs.irqs[0]);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed enabling interrupt: %s", str_error(rc));
+		ddf_msg(LVL_ERROR, "Failed enabling interrupt. (%d)", rc);
 		goto error;
 	}
@@ -237,5 +236,5 @@
 }
 
-static errno_t pl050_read(chardev_srv_t *srv, void *buffer, size_t size,
+static int pl050_read(chardev_srv_t *srv, void *buffer, size_t size,
     size_t *nread)
 {
@@ -263,5 +262,5 @@
 }
 
-static errno_t pl050_write(chardev_srv_t *srv, const void *data, size_t size,
+static int pl050_write(chardev_srv_t *srv, const void *data, size_t size,
     size_t *nwritten)
 {
@@ -294,10 +293,10 @@
 
 /** Add device. */
-static errno_t pl050_dev_add(ddf_dev_t *dev)
+static int pl050_dev_add(ddf_dev_t *dev)
 {
 	ddf_fun_t *fun_a;
 	pl050_t *pl050 = NULL;
 	const char *mname;
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "pl050_dev_add()");
@@ -350,5 +349,5 @@
 	rc = ddf_fun_bind(fun_a);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function 'a': %s", str_error(rc));
+		ddf_msg(LVL_ERROR, "Failed binding function 'a'. (%d)", rc);
 		ddf_fun_destroy(fun_a);
 		goto error;
@@ -363,5 +362,5 @@
 }
 
-static errno_t pl050_fun_online(ddf_fun_t *fun)
+static int pl050_fun_online(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "pl050_fun_online()");
@@ -369,5 +368,5 @@
 }
 
-static errno_t pl050_fun_offline(ddf_fun_t *fun)
+static int pl050_fun_offline(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "pl050_fun_offline()");
@@ -377,5 +376,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	printf(NAME ": HelenOS pl050 serial device driver\n");
Index: uspace/drv/char/ski-con/main.c
===================================================================
--- uspace/drv/char/ski-con/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/ski-con/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,9 +42,9 @@
 #define NAME  "ski-con"
 
-static errno_t ski_con_dev_add(ddf_dev_t *dev);
-static errno_t ski_con_dev_remove(ddf_dev_t *dev);
-static errno_t ski_con_dev_gone(ddf_dev_t *dev);
-static errno_t ski_con_fun_online(ddf_fun_t *fun);
-static errno_t ski_con_fun_offline(ddf_fun_t *fun);
+static int ski_con_dev_add(ddf_dev_t *dev);
+static int ski_con_dev_remove(ddf_dev_t *dev);
+static int ski_con_dev_gone(ddf_dev_t *dev);
+static int ski_con_fun_online(ddf_fun_t *fun);
+static int ski_con_fun_offline(ddf_fun_t *fun);
 
 static driver_ops_t driver_ops = {
@@ -61,5 +61,5 @@
 };
 
-static errno_t ski_con_dev_add(ddf_dev_t *dev)
+static int ski_con_dev_add(ddf_dev_t *dev)
 {
 	ski_con_t *ski_con;
@@ -77,5 +77,5 @@
 }
 
-static errno_t ski_con_dev_remove(ddf_dev_t *dev)
+static int ski_con_dev_remove(ddf_dev_t *dev)
 {
         ski_con_t *ski_con = (ski_con_t *)ddf_dev_data_get(dev);
@@ -86,5 +86,5 @@
 }
 
-static errno_t ski_con_dev_gone(ddf_dev_t *dev)
+static int ski_con_dev_gone(ddf_dev_t *dev)
 {
         ski_con_t *ski_con = (ski_con_t *)ddf_dev_data_get(dev);
@@ -95,5 +95,5 @@
 }
 
-static errno_t ski_con_fun_online(ddf_fun_t *fun)
+static int ski_con_fun_online(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "ski_con_fun_online()");
@@ -101,5 +101,5 @@
 }
 
-static errno_t ski_con_fun_offline(ddf_fun_t *fun)
+static int ski_con_fun_offline(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "ski_con_fun_offline()");
Index: uspace/drv/char/ski-con/ski-con.c
===================================================================
--- uspace/drv/char/ski-con/ski-con.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/ski-con/ski-con.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,10 +48,10 @@
 #define POLL_INTERVAL		10000
 
-static errno_t ski_con_fibril(void *arg);
+static int ski_con_fibril(void *arg);
 static int32_t ski_con_getchar(void);
 static void ski_con_connection(ipc_callid_t, ipc_call_t *, void *);
 
-static errno_t ski_con_read(chardev_srv_t *, void *, size_t, size_t *);
-static errno_t ski_con_write(chardev_srv_t *, const void *, size_t, size_t *);
+static int ski_con_read(chardev_srv_t *, void *, size_t, size_t *);
+static int ski_con_write(chardev_srv_t *, const void *, size_t, size_t *);
 
 static chardev_ops_t ski_con_chardev_ops = {
@@ -63,10 +63,10 @@
 
 /** Add ski console device. */
-errno_t ski_con_add(ski_con_t *con)
+int ski_con_add(ski_con_t *con)
 {
 	fid_t fid;
 	ddf_fun_t *fun = NULL;
 	bool bound = false;
-	errno_t rc;
+	int rc;
 
 	circ_buf_init(&con->cbuf, con->buf, ski_con_buf_size, 1);
@@ -116,5 +116,5 @@
 
 /** Remove ski console device */
-errno_t ski_con_remove(ski_con_t *con)
+int ski_con_remove(ski_con_t *con)
 {
 	return ENOTSUP;
@@ -122,5 +122,5 @@
 
 /** Ski console device gone */
-errno_t ski_con_gone(ski_con_t *con)
+int ski_con_gone(ski_con_t *con)
 {
 	return ENOTSUP;
@@ -128,9 +128,9 @@
 
 /** Poll Ski for keypresses. */
-static errno_t ski_con_fibril(void *arg)
+static int ski_con_fibril(void *arg)
 {
 	int32_t c;
 	ski_con_t *con = (ski_con_t *) arg;
-	errno_t rc;
+	int rc;
 
 	while (1) {
@@ -212,5 +212,5 @@
 
 /** Read from Ski console device */
-static errno_t ski_con_read(chardev_srv_t *srv, void *buf, size_t size,
+static int ski_con_read(chardev_srv_t *srv, void *buf, size_t size,
     size_t *nread)
 {
@@ -218,5 +218,5 @@
 	size_t p;
 	uint8_t *bp = (uint8_t *) buf;
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_lock(&con->buf_lock);
@@ -240,5 +240,5 @@
 
 /** Write to Ski console device */
-static errno_t ski_con_write(chardev_srv_t *srv, const void *data, size_t size,
+static int ski_con_write(chardev_srv_t *srv, const void *data, size_t size,
     size_t *nwr)
 {
Index: uspace/drv/char/ski-con/ski-con.h
===================================================================
--- uspace/drv/char/ski-con/ski-con.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/ski-con/ski-con.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,7 +58,7 @@
 } ski_con_t;
 
-extern errno_t ski_con_add(ski_con_t *);
-extern errno_t ski_con_remove(ski_con_t *);
-extern errno_t ski_con_gone(ski_con_t *);
+extern int ski_con_add(ski_con_t *);
+extern int ski_con_remove(ski_con_t *);
+extern int ski_con_gone(ski_con_t *);
 
 #endif
Index: uspace/drv/char/sun4v-con/main.c
===================================================================
--- uspace/drv/char/sun4v-con/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/sun4v-con/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,9 +40,9 @@
 #define NAME  "sun4v-con"
 
-static errno_t sun4v_con_dev_add(ddf_dev_t *dev);
-static errno_t sun4v_con_dev_remove(ddf_dev_t *dev);
-static errno_t sun4v_con_dev_gone(ddf_dev_t *dev);
-static errno_t sun4v_con_fun_online(ddf_fun_t *fun);
-static errno_t sun4v_con_fun_offline(ddf_fun_t *fun);
+static int sun4v_con_dev_add(ddf_dev_t *dev);
+static int sun4v_con_dev_remove(ddf_dev_t *dev);
+static int sun4v_con_dev_gone(ddf_dev_t *dev);
+static int sun4v_con_fun_online(ddf_fun_t *fun);
+static int sun4v_con_fun_offline(ddf_fun_t *fun);
 
 static driver_ops_t driver_ops = {
@@ -59,9 +59,9 @@
 };
 
-static errno_t sun4v_con_get_res(ddf_dev_t *dev, sun4v_con_res_t *res)
+static int sun4v_con_get_res(ddf_dev_t *dev, sun4v_con_res_t *res)
 {
 	async_sess_t *parent_sess;
 	hw_res_list_parsed_t hw_res;
-	errno_t rc;
+	int rc;
 
 	parent_sess = ddf_dev_parent_sess_get(dev);
@@ -88,9 +88,9 @@
 
 
-static errno_t sun4v_con_dev_add(ddf_dev_t *dev)
+static int sun4v_con_dev_add(ddf_dev_t *dev)
 {
 	sun4v_con_t *sun4v_con;
 	sun4v_con_res_t res;
-	errno_t rc;
+	int rc;
 
         ddf_msg(LVL_DEBUG, "sun4v_con_dev_add(%p)", dev);
@@ -112,5 +112,5 @@
 }
 
-static errno_t sun4v_con_dev_remove(ddf_dev_t *dev)
+static int sun4v_con_dev_remove(ddf_dev_t *dev)
 {
         sun4v_con_t *sun4v_con = (sun4v_con_t *)ddf_dev_data_get(dev);
@@ -121,5 +121,5 @@
 }
 
-static errno_t sun4v_con_dev_gone(ddf_dev_t *dev)
+static int sun4v_con_dev_gone(ddf_dev_t *dev)
 {
         sun4v_con_t *sun4v_con = (sun4v_con_t *)ddf_dev_data_get(dev);
@@ -130,5 +130,5 @@
 }
 
-static errno_t sun4v_con_fun_online(ddf_fun_t *fun)
+static int sun4v_con_fun_online(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "sun4v_con_fun_online()");
@@ -136,5 +136,5 @@
 }
 
-static errno_t sun4v_con_fun_offline(ddf_fun_t *fun)
+static int sun4v_con_fun_offline(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "sun4v_con_fun_offline()");
Index: uspace/drv/char/sun4v-con/sun4v-con.c
===================================================================
--- uspace/drv/char/sun4v-con/sun4v-con.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/sun4v-con/sun4v-con.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #include <ddi.h>
 #include <errno.h>
-#include <str_error.h>
 #include <io/chardev_srv.h>
 #include <stdbool.h>
@@ -46,6 +45,6 @@
 #define POLL_INTERVAL  10000
 
-static errno_t sun4v_con_read(chardev_srv_t *, void *, size_t, size_t *);
-static errno_t sun4v_con_write(chardev_srv_t *, const void *, size_t, size_t *);
+static int sun4v_con_read(chardev_srv_t *, void *, size_t, size_t *);
+static int sun4v_con_write(chardev_srv_t *, const void *, size_t, size_t *);
 
 static chardev_ops_t sun4v_con_chardev_ops = {
@@ -69,8 +68,8 @@
 
 /** Add sun4v console device. */
-errno_t sun4v_con_add(sun4v_con_t *con, sun4v_con_res_t *res)
+int sun4v_con_add(sun4v_con_t *con, sun4v_con_res_t *res)
 {
 	ddf_fun_t *fun = NULL;
-	errno_t rc;
+	int rc;
 
 	con->res = *res;
@@ -93,5 +92,5 @@
 	    (void *) &con->input_buffer);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Error mapping memory: %s", str_error_name(rc));
+		ddf_msg(LVL_ERROR, "Error mapping memory: %d", rc);
 		goto error;
 	}
@@ -102,5 +101,5 @@
 	    (void *) &con->output_buffer);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Error mapping memory: %s", str_error_name(rc));
+		ddf_msg(LVL_ERROR, "Error mapping memory: %d", rc);
 		return rc;
 	}
@@ -129,5 +128,5 @@
 
 /** Remove sun4v console device */
-errno_t sun4v_con_remove(sun4v_con_t *con)
+int sun4v_con_remove(sun4v_con_t *con)
 {
 	return ENOTSUP;
@@ -135,5 +134,5 @@
 
 /** Msim console device gone */
-errno_t sun4v_con_gone(sun4v_con_t *con)
+int sun4v_con_gone(sun4v_con_t *con)
 {
 	return ENOTSUP;
@@ -141,5 +140,5 @@
 
 /** Read from Sun4v console device */
-static errno_t sun4v_con_read(chardev_srv_t *srv, void *buf, size_t size,
+static int sun4v_con_read(chardev_srv_t *srv, void *buf, size_t size,
     size_t *nread)
 {
@@ -165,5 +164,5 @@
 
 /** Write to Sun4v console device */
-static errno_t sun4v_con_write(chardev_srv_t *srv, const void *data, size_t size,
+static int sun4v_con_write(chardev_srv_t *srv, const void *data, size_t size,
     size_t *nwr)
 {
Index: uspace/drv/char/sun4v-con/sun4v-con.h
===================================================================
--- uspace/drv/char/sun4v-con/sun4v-con.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/sun4v-con/sun4v-con.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -62,7 +62,7 @@
 } sun4v_con_t;
 
-extern errno_t sun4v_con_add(sun4v_con_t *, sun4v_con_res_t *);
-extern errno_t sun4v_con_remove(sun4v_con_t *);
-extern errno_t sun4v_con_gone(sun4v_con_t *);
+extern int sun4v_con_add(sun4v_con_t *, sun4v_con_res_t *);
+extern int sun4v_con_remove(sun4v_con_t *);
+extern int sun4v_con_gone(sun4v_con_t *);
 
 #endif
Index: uspace/drv/fb/amdm37x_dispc/amdm37x_dispc.c
===================================================================
--- uspace/drv/fb/amdm37x_dispc/amdm37x_dispc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/fb/amdm37x_dispc/amdm37x_dispc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -56,9 +56,9 @@
 
 
-static errno_t change_mode(visualizer_t *vis, vslmode_t mode);
-static errno_t handle_damage(visualizer_t *vs,
+static int change_mode(visualizer_t *vis, vslmode_t mode);
+static int handle_damage(visualizer_t *vs,
     sysarg_t x0, sysarg_t y0, sysarg_t width, sysarg_t height,
     sysarg_t x_offset, sysarg_t y_offset);
-static errno_t dummy(visualizer_t *vs)
+static int dummy(visualizer_t *vs)
 {
 	return EOK;
@@ -115,5 +115,5 @@
 }
 
-errno_t amdm37x_dispc_init(amdm37x_dispc_t *instance, visualizer_t *vis)
+int amdm37x_dispc_init(amdm37x_dispc_t *instance, visualizer_t *vis)
 {
 	assert(instance);
@@ -134,5 +134,5 @@
 	}
 
-	errno_t ret = pio_enable((void*)AMDM37x_DISPC_BASE_ADDRESS,
+	int ret = pio_enable((void*)AMDM37x_DISPC_BASE_ADDRESS,
 	    AMDM37x_DISPC_SIZE, (void**)&instance->regs);
 	if (ret != EOK) {
@@ -152,10 +152,10 @@
 };
 
-errno_t amdm37x_dispc_fini(amdm37x_dispc_t *instance)
+int amdm37x_dispc_fini(amdm37x_dispc_t *instance)
 {
 	return EOK;
 };
 
-static errno_t amdm37x_dispc_setup_fb(amdm37x_dispc_regs_t *regs,
+static int amdm37x_dispc_setup_fb(amdm37x_dispc_regs_t *regs,
     unsigned x, unsigned y, unsigned bpp, uint32_t pa)
 {
@@ -260,5 +260,5 @@
 }
 
-static errno_t change_mode(visualizer_t *vis, vslmode_t mode)
+static int change_mode(visualizer_t *vis, vslmode_t mode)
 {
 	assert(vis);
@@ -276,5 +276,5 @@
 	uintptr_t pa;
 	void *buffer = AS_AREA_ANY;
-	errno_t ret = dmamem_map_anonymous(size, DMAMEM_4GiB,
+	int ret = dmamem_map_anonymous(size, DMAMEM_4GiB,
 	    AS_AREA_READ | AS_AREA_WRITE, 0, &pa, &buffer);
 	if (ret != EOK) {
@@ -299,5 +299,5 @@
 }
 
-static errno_t handle_damage(visualizer_t *vs,
+static int handle_damage(visualizer_t *vs,
     sysarg_t x0, sysarg_t y0, sysarg_t width, sysarg_t height,
     sysarg_t x_offset, sysarg_t y_offset)
Index: uspace/drv/fb/amdm37x_dispc/amdm37x_dispc.h
===================================================================
--- uspace/drv/fb/amdm37x_dispc/amdm37x_dispc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/fb/amdm37x_dispc/amdm37x_dispc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -62,6 +62,6 @@
 } amdm37x_dispc_t;
 
-errno_t amdm37x_dispc_init(amdm37x_dispc_t *instance, visualizer_t *vis);
-errno_t amdm37x_dispc_fini(amdm37x_dispc_t *instance);
+int amdm37x_dispc_init(amdm37x_dispc_t *instance, visualizer_t *vis);
+int amdm37x_dispc_fini(amdm37x_dispc_t *instance);
 
 #endif
Index: uspace/drv/fb/amdm37x_dispc/main.c
===================================================================
--- uspace/drv/fb/amdm37x_dispc/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/fb/amdm37x_dispc/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -54,5 +54,5 @@
 }
 
-static errno_t amdm37x_dispc_dev_add(ddf_dev_t *dev)
+static int amdm37x_dispc_dev_add(ddf_dev_t *dev)
 {
 	assert(dev);
@@ -84,5 +84,5 @@
 	}
 
-	errno_t ret = amdm37x_dispc_init(dispc, vis);
+	int ret = amdm37x_dispc_init(dispc, vis);
 	if (ret != EOK) {
 		ddf_log_error("Failed to init dispc: %s\n", str_error(ret));
Index: uspace/drv/fb/kfb/kfb.c
===================================================================
--- uspace/drv/fb/kfb/kfb.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/fb/kfb/kfb.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
 #include "kfb.h"
 
-static errno_t kgraph_dev_add(ddf_dev_t *dev)
+static int kgraph_dev_add(ddf_dev_t *dev)
 {
 	port_init(dev);
Index: uspace/drv/fb/kfb/port.c
===================================================================
--- uspace/drv/fb/kfb/port.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/fb/kfb/port.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -86,5 +86,5 @@
 static vslmode_list_element_t pixel_mode;
 
-static errno_t kfb_claim(visualizer_t *vs)
+static int kfb_claim(visualizer_t *vs)
 {
 	return physmem_map(kfb.paddr + kfb.offset,
@@ -93,7 +93,7 @@
 }
 
-static errno_t kfb_yield(visualizer_t *vs)
-{
-	errno_t rc;
+static int kfb_yield(visualizer_t *vs)
+{
+	int rc;
 
 	if (vs->mode_set) {
@@ -109,5 +109,5 @@
 }
 
-static errno_t kfb_handle_damage_pixels(visualizer_t *vs,
+static int kfb_handle_damage_pixels(visualizer_t *vs,
     sysarg_t x0, sysarg_t y0, sysarg_t width, sysarg_t height,
     sysarg_t x_offset, sysarg_t y_offset)
@@ -137,5 +137,5 @@
 }
 
-static errno_t kfb_change_mode(visualizer_t *vs, vslmode_t new_mode)
+static int kfb_change_mode(visualizer_t *vs, vslmode_t new_mode)
 {
 	vs->ops.handle_damage = kfb_handle_damage_pixels;
@@ -143,10 +143,10 @@
 }
 
-static errno_t kfb_suspend(visualizer_t *vs)
-{
-	return EOK;
-}
-
-static errno_t kfb_wakeup(visualizer_t *vs)
+static int kfb_suspend(visualizer_t *vs)
+{
+	return EOK;
+}
+
+static int kfb_wakeup(visualizer_t *vs)
 {
 	return EOK;
@@ -165,5 +165,5 @@
 {
 	visualizer_t *vsl;
-	errno_t rc;
+	int rc;
 
 	vsl = (visualizer_t *) ddf_fun_data_get((ddf_fun_t *)arg);
@@ -177,8 +177,8 @@
 }
 
-errno_t port_init(ddf_dev_t *dev)
+int port_init(ddf_dev_t *dev)
 {
 	sysarg_t present;
-	errno_t rc = sysinfo_get_value("fb", &present);
+	int rc = sysinfo_get_value("fb", &present);
 	if (rc != EOK)
 		present = false;
Index: uspace/drv/fb/kfb/port.h
===================================================================
--- uspace/drv/fb/kfb/port.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/fb/kfb/port.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,5 @@
 #include <ddf/driver.h>
 
-extern errno_t port_init(ddf_dev_t *);
+extern int port_init(ddf_dev_t *);
 
 #endif
Index: uspace/drv/hid/adb-kbd/adb-kbd.c
===================================================================
--- uspace/drv/hid/adb-kbd/adb-kbd.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/hid/adb-kbd/adb-kbd.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,7 +48,7 @@
 
 /** Add ADB keyboard device */
-errno_t adb_kbd_add(adb_kbd_t *kbd)
-{
-	errno_t rc;
+int adb_kbd_add(adb_kbd_t *kbd)
+{
+	int rc;
 	bool bound = false;
 
@@ -119,5 +119,5 @@
 
 /** Remove ADB keyboard device */
-errno_t adb_kbd_remove(adb_kbd_t *con)
+int adb_kbd_remove(adb_kbd_t *con)
 {
 	return ENOTSUP;
@@ -125,5 +125,5 @@
 
 /** ADB keyboard device gone */
-errno_t adb_kbd_gone(adb_kbd_t *con)
+int adb_kbd_gone(adb_kbd_t *con)
 {
 	return ENOTSUP;
@@ -140,5 +140,5 @@
 		ipc_callid_t callid = async_get_call(&call);
 
-		errno_t retval = EOK;
+		int retval = EOK;
 
 		if (!IPC_GET_IMETHOD(call)) {
@@ -162,5 +162,5 @@
 	kbd_event_type_t etype;
 	unsigned int key;
-	errno_t rc;
+	int rc;
 
 	rc = adb_kbd_key_translate(b, &etype, &key);
Index: uspace/drv/hid/adb-kbd/adb-kbd.h
===================================================================
--- uspace/drv/hid/adb-kbd/adb-kbd.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/hid/adb-kbd/adb-kbd.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,7 +44,7 @@
 } adb_kbd_t;
 
-extern errno_t adb_kbd_add(adb_kbd_t *);
-extern errno_t adb_kbd_remove(adb_kbd_t *);
-extern errno_t adb_kbd_gone(adb_kbd_t *);
+extern int adb_kbd_add(adb_kbd_t *);
+extern int adb_kbd_remove(adb_kbd_t *);
+extern int adb_kbd_gone(adb_kbd_t *);
 
 #endif
Index: uspace/drv/hid/adb-kbd/ctl.c
===================================================================
--- uspace/drv/hid/adb-kbd/ctl.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/hid/adb-kbd/ctl.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -179,5 +179,5 @@
  * @return EOK on success, ENOENT if no translation exists
  */
-errno_t adb_kbd_key_translate(sysarg_t scancode, kbd_event_type_t *rtype,
+int adb_kbd_key_translate(sysarg_t scancode, kbd_event_type_t *rtype,
     unsigned int *rkey)
 {
Index: uspace/drv/hid/adb-kbd/ctl.h
===================================================================
--- uspace/drv/hid/adb-kbd/ctl.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/hid/adb-kbd/ctl.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -35,5 +35,5 @@
 #define CTL_H
 
-extern errno_t adb_kbd_key_translate(sysarg_t, kbd_event_type_t *, unsigned int *);
+extern int adb_kbd_key_translate(sysarg_t, kbd_event_type_t *, unsigned int *);
 
 #endif
